
hirom

; game hooks

org $C07962
CPX #$2008 ; prevent erasing msu flags

org $C088AA 
JSL pauseStart
NOP
NOP

org $C0888E
JSL pauseEnd
NOP
NOP

org $C21BDE
JSL MsuTrack

org $C467B9
JSL startOnMenu
NOP


org $C08AF3
JSL stopMSUdeath

org $C0960E 
JSL resetstartbuttonflag


; free rom space for patch code
org $C5C1D0

stopMSUdeath:
LDA #$0000
STA $002007
STA $7e0102
LDA $7FFFAA
RTL

resetstartbuttonflag:
	LDA #$0000
	STA $7e0100
	JSL $C1C597
	RTL

startOnMenu:
	LDA $0068
	STA $00
	LDA $7EB241
	CMP #$0001
	BNE $01
	RTL
	LDA #$0001
	STA $7e0100
	RTL

pauseStart:
	LDA $002002
	CMP #$2D53
	BNE $07
	LDA #$0000
	STA $002007 
	LDA #$0001
	STA $0A89
	RTL

pauseEnd:
	LDA $002002
	CMP #$2D53
	BNE $07
	LDA #$0003
	STA $002007 
	STZ $0A89
	LDA #$0001
	RTL

MsuTrack:
	PHA
	LDA $002002
	CMP #$2D53 ; this area of code is 16bit A, have to use $2D53
	BEQ stFoundMsu
	PLA
	STX $1F
	STY $24
	RTL
stFoundMsu:
	LDA #$0000 ; mute spc
	STA $7fff94
	JSL playTrack ; find msu tracks and store loop values @ $0001C0 for spc2msu routine
	STX $1F ; native code, was missing
	STY $24 ; native code, was missing
	PLA	
	RTL

; find track and play msu
playTrack:
	PHP
	REP #$20 ; cannot use 16bit values on sd2snes, won't work right, this makes 16bit -> PEV to Kurrono
	CPY #$e67b ; Intro,Cicle of Life
	BNE t000
	LDA #$0001
	JSL msuPlay
	JMP leave
t000:
	CPY #$e7cb ; PrideLands
	BNE t001
	LDA #$0002
	JSL msuPlay
	JMP leave
t001:
	CPY #$e0f3 ; Cant wait to be king
	BNE t002
	LDA #$0003
	JSL msuPlay
	JMP leave
t002:
	CPY #$d901 ; Elephant graveyard
	BNE t003
	LDA #$0004
	JSL msuPlay
	JMP leave
t003:
	CPY #$eb8a ; Stampede
	BNE t004
	LDA #$0005
	JSL msuPlay
	JMP leave
t004:
    CPY #$df6d ; Simba's exile
	BNE t005
	LDA #$0006
	JSL msuPlay	
	JMP leave
t005:
	CPY #$d59b ; Hakuna Matata
	BNE t006
	LDA #$0007
	JSL msuPlay	
	JMP leave
t006:
	CPY #$daa9 ; Simba's Destiny
	BNE t007
	LDA #$0008
	JSL msuPlay
	JMP leave
t007:
	CPY #$fe7f ; Be Prepared
	BNE t008
	LDA #$0009
	JSL msuPlay
	JMP leave
t008:
	CPY #$dde3 ; Simba's Return
	BNE t009
	LDA #$000A
	JSL msuPlay
	JMP leave
t009:	
	CPY #$d1d5 ; Pride Rock
	BNE t010
	LDA #$000B
	JSL msuPlay
	JMP leave
t010:
	CPY #$efb0 ; bug hunt
	BNE t011
	LDA #$000C
	JSL msuPlay
	JMP leave
t011:
	CPY #$f05a ; bug toss
	BNE t012
	LDA #$000D
	JSL msuPlay
	JMP leave
t012:
	CPY #$f0e4 ; continue
	BNE t013
	LDA #$000E
	JSL msuPlay
	JMP leave
t013:
	CPY #$FEE4 ; ending
	BNE t014
	LDA #$000F
	JSL msuPlay
	JMP leave
t014:
	CPY #$ed58 ; credits
	BNE t015
	LDA #$0010
	JSL msuPlay
	JMP leave
t015:
    CPY #$ffde ; dying
	BNE t016
	LDA #$0011
	JSL msuPlay
	JMP leave
t016:
    CPY #$e3cd ; hyena boss
	BNE t017
	LDA #$0012
	JSL msuPlay
	JMP leave
t017:
	LDA #$0001 ; enable spc (no track found)
	STA $7fff94
	LDA #$0000
	STA $002007
leave:
	SEP #$20
	PLP
	RTL


; msu1 playback routine
msuPlay:
	SEP #$20
	PHB
	PHA
	LDA #$00
	PHA
	PLB
	PLA
	CMP $7e0102
	BEQ endroutine
	cmp #$01
	BEQ play
	PHA
	LDA $7e0100
	CMP #$01
	BNE $03
	PLA
	BRA play
	LDA $7EB265
	CMP #$00
	BEQ $03
	PLA
	BRA play
	LDA $7EB266
	BEQ $03
	PLA
	BRA play
	PLA
	BRA endroutine	
	play:
	STZ $2006
	STA $2004
	STA $7e0102
	STZ $2005 ; need since we made A 8bit again with SEP #$20
loopTitle:
	BIT $2000
	BVS loopTitle ; track not ready
	LDA #$FF ; max volume
	STA $2006
    CPY #$df6d ; Simba's exile
	BEQ sta01
	CPY #$d1d5 ; Pride Rock
	BEQ sta01
    CPY #$ffde ; dying
	BEQ sta01
	LDA #$03
	BRA $02
sta01:	
	LDA #$01
	STA $2007
endroutine:
	PLB
	REP #$20
	RTL


